Attribute VB_Name = "mdlFindFiles"
Option Explicit

Public StopSearch As Boolean
  Public FilesOfDir() As String
  Public FilesToMuch() As String
  Public FilesOfPlaylist() As String
  Public ToMuchState As Long
  Public FilesToMuchUBound As Long
  Public PlaylistState As Long
  Public PlaylistUBound As Long
  
Private Declare Function FindFirstFile Lib "kernel32" _
  Alias "FindFirstFileA" (ByVal lpFileName As String, _
  lpFindFileData As WIN32_FIND_DATA) As Long
Private Declare Function FindNextFile Lib "kernel32" _
  Alias "FindNextFileA" (ByVal hFindFile As Long, _
  lpFindFileData As WIN32_FIND_DATA) As Long
Private Declare Function FindClose Lib "kernel32" _
  (ByVal hFindFile As Long) As Long
Private Declare Function GetShortPathName Lib "kernel32" _
  Alias "GetShortPathNameA" (ByVal lpszLongPath As String, _
  ByVal lpszShortPath As String, ByVal cchBuffer As Long) _
  As Long
  
  Private Const MAX_PATH = 260
Private Const INVALID_HANDLE_VALUE = -1

Public Type FILETIME
  dwLowDateTime As Long
  dwHighDateTime As Long
End Type

Private Type WIN32_FIND_DATA
  dwFileAttributes As Long ' Dateiattribute
  ftCreationTime As FILETIME ' Erstellungsdatum
  ftLastAccessTime As FILETIME ' Letzter Zugriff
  ftLastWriteTime As FILETIME ' Letzte Speicherung
  nFileSizeHigh As Long ' Gre (Hi)
  nFileSizeLow As Long ' Gre (Lo)
  dwReserved0 As Long ' bedeutungslos
  dwReserved1 As Long ' bedeutungslos
  cFileName As String * MAX_PATH ' Dateiname
  cAlternate As String * 14 ' 8.3-Dateiname
End Type

Public Type Datei
  Pfadname As String
  DosDateiname As String
  Dateiname As String
  ErstelltAM As FILETIME
  LetzterZugriff As FILETIME
  Letzenderung As FILETIME
  DateiGre As Long
  Atribute As Long
End Type
  

Public Function FindFile(ByVal StartPath As String, _
  ByVal SearchSubfolder As Boolean, _
  ByVal File As String, _
  ByRef FileFound() As Datei)
  
  Dim hFile As Long
  Dim FileData As WIN32_FIND_DATA
  Dim Directories() As String
  Dim OnlyDirectories As Boolean
  Dim TmpFile As String
  Dim i As Integer
   
  DoEvents
    
 ' Evtl. Backslash entfernen
 If Right$(StartPath, 1) = "\" Then _
   StartPath = Left$(StartPath, Len(StartPath) - 1)
 
SearchOnlySubfolders:
 
  ' Sucht nach einer Datei, und packt das
  ' Ergebnis in FileData
  hFile = FindFirstFile(StartPath & "\" & File & _
    vbNullChar, FileData)
      
  ' Wenn sie gefunden wurde, dann...
  If hFile <> INVALID_HANDLE_VALUE Then
    
    Do
      ' Ist es ein Verzeichniss oder eine Datei ?
      With FileData
        If (.dwFileAttributes And vbDirectory) = 0 Then
          ' Datei
        
          ' Nur wenn nicht nur Verzeichinsse gesucht werden
          If Not OnlyDirectories Then
            ' Array vergrern und Daten ins Array schreiben
            On Error GoTo Err_DimFile
            ReDim Preserve FileFound(UBound(FileFound) + 1)
            On Error GoTo 0
            
            DoEvents
            UmPacken FileFound(UBound(FileFound)), _
              FileData, StartPath & "\" & File
          
          End If
          If StopSearch = True Then Exit Function
         
        ElseIf SearchSubfolder = True Then
          ' Verzeichnis
          
          ' Verzeichnis nur im Array Speichern wenn es
          ' ber dem jetzigen liegt d.h. ".." "." sind
          ' nicht gltig
          If Left$(.cFileName, InStr(.cFileName, vbNullChar) - 1) <> "." _
            And Left$(.cFileName, InStr(.cFileName, vbNullChar) - 1) <> ".." Then
            
            On Error GoTo Err_DimDir
            ReDim Preserve Directories(UBound(Directories) + 1)
            On Error GoTo 0
            
            ' Verzeichnis dem Array hinzufgen
            Directories(UBound(Directories)) = _
              Left$(.cFileName, InStr(.cFileName, vbNullChar) - 1)
          End If
       
        End If
      End With
      DoEvents
    Loop Until FindNextFile(hFile, FileData) = 0 Or StopSearch = True
  End If
  FindClose hFile
    
  ' Unteroder durchsuchen
  On Error GoTo Err_DimDir
  If SearchSubfolder = False Or _
    StopSearch = True Then Exit Function
  On Error GoTo 0
    
  ' Wenn nach anderen Dateien als *.* gesucht wird,
  ' werden keine Ordner gefunden
  ' Deshalb noch einmal gezielt nach Ordnern suchen
  If Not OnlyDirectories And SearchSubfolder = True And _
    File <> "*.*" Then
    
    OnlyDirectories = True
    TmpFile = File
    File = "*.*"
    GoTo SearchOnlySubfolders
  ElseIf TmpFile <> "" Then
    File = TmpFile
  End If
    
  On Error GoTo Err_Exit
  For i = 0 To UBound(Directories)
    If StopSearch = True Then Exit Function
    DoEvents
     
    ' Hier ruft die Funktion sich selbst auf - fr
    ' jeden Unterordner
    FindFile StartPath & "\" & Directories(i), _
      SearchSubfolder, File, FileFound
  Next i
  Exit Function
   
Err_DimFile:
   ReDim FileFound(0)
   Resume Next

Err_DimDir:
   ReDim Directories(0)
   Resume Next

Err_Exit:

End Function

Private Function UmPacken(ByRef D As Datei, _
  FD As WIN32_FIND_DATA, ByVal Path As String)
  
  With FD
    D.Atribute = .dwFileAttributes
    D.DateiGre = .nFileSizeLow
    D.Dateiname = Left$(.cFileName, InStr(.cFileName, _
      vbNullChar) - 1)
    D.DosDateiname = Left$(.cAlternate, _
      InStr(.cAlternate, vbNullChar) - 1)
    If D.DosDateiname = "" Then _
      D.DosDateiname = D.Dateiname
    D.ErstelltAM = .ftCreationTime
    D.Letzenderung = .ftLastWriteTime
    D.LetzterZugriff = .ftLastAccessTime
    D.Pfadname = Left$(Path, InStrRev(Path, "\"))
  End With
End Function

Public Function KillUnNeeded(FileDir As String)
Dim CompareNum As Long
Dim FileNumber As Long
Dim KillState As Long
Dim KillNumber As Long
KillNumber = 0
ToMuchState = 0

For CompareNum = 0 To UBound(FilesOfDir)
    For FileNumber = 0 To PlaylistState
        If (Not (FilesOfPlaylist(FileNumber) = FilesOfDir(CompareNum))) And (FilesToMuch(CompareNum, 1) = "" Or FilesToMuch(CompareNum, 1) = "kill") Then
            FilesToMuch(CompareNum, 0) = FilesOfDir(CompareNum)
            FilesToMuch(CompareNum, 1) = "kill"
            KillNumber = KillNumber + 1
        Else
             FilesToMuch(CompareNum, 0) = FilesOfDir(CompareNum)
            FilesToMuch(CompareNum, 1) = "keep"
            'Error Somewhere here
            
            Exit For
        End If
        
    Next FileNumber
Next CompareNum

    If KillNumber > 0 Then
    frmPlaylistExporter.pgbCopy.Max = KillNumber
    frmPlaylistExporter.pgbCopy.Value = 0
    
        For KillState = 0 To UBound(FilesOfDir)
On Error Resume Next
        If FilesToMuch(KillState, 1) = "kill" Then
            frmPlaylistExporter.pgbCopy.Value = KillState
            frmPlaylistExporter.stbStatus.Panels(1).Text = "Killing Files"
            frmPlaylistExporter.stbStatus.Panels(2).Text = "Killing: " & FilesToMuch(KillState, 0)
            Call Kill(FileDir & "\" & FilesToMuch(KillState, 0))
        End If
        Next KillState
    frmPlaylistExporter.pgbCopy.Value = 100
    frmPlaylistExporter.pgbCopy.Max = 100
    End If
End Function
